﻿Option Strict On

Imports System.Windows.Forms
Imports System.ComponentModel
Imports Microsoft.VisualBasic


Public Class MuxControl

   Public Event UserChangedControlSettings(frmParentForm As Form, bShowIt As Boolean) 'Dieses Ereignis signalisiert, dass an dieser Instanz des ACU-Controls seitens des Benutzers eine Eingabe/Änderung durchgeführt wurde.

   Const csStandardFormatForVoltagesInLiveView As String = "0.000" 'Format für die Zahlendarstellungen

   Const ciControlSizeHeightWhenControlExpanded As Integer = 56

   Const ciExpandControlButtonSizeHeightWhenControlExpanded As Integer = 25
   Const ciExpandControlButtonSizeHeightWhenControlNOTExpanded As Integer = 25

   Dim iControlSizeWidthWhenControlExpanded As Integer = 190

   Dim iExpandControlButtonSizeWidthWhenControlNOTExpanded As Integer = 130

   'Dim sNameAtDisable As String = ""
   Dim dControlOutputValue As Double
   Dim bLiveViewEnabled As Boolean

   Dim bSomehowSelectionChanged As Boolean = False
   Dim bUserChangedControlSettings As Boolean = False

   Dim bFormLoaded As Boolean = False

   Dim sControlName As String = "Multiplexer"   'Name des Controls, wird angezeigt, wenn mit 'pbExpandControlButtonVisible = TRUE' 'chk_ExpandControl' sichtbar und AUSgeklappt ist,
                                                'sofern 'pbUseUserDefindedMarkingForchk_ExpandControl_Text = FALSE' ist. Sonst wird 'psUserDefindedMarkingForchk_ExpandControl_Text' angezeigt.
                                                'Ist das MuxControl mit sichtbarem 'chk_ExpandControl' EINgeklappt wird darauf abhängig von 'pbUseUserDefindedMarkingForchk_ExpandControl_Text'
                                                'entweder die selektierte Auswahl aus 'cbo_MultiplexerChoiceBox' oder 'psUserDefindedMarkingForchk_ExpandControl_Text' angezeigt.

   Dim bUseUserDefindedMarkingForchk_ExpandControl_Text As Boolean = False
   Dim sUserDefindedMarkingForchk_ExpandControl_Text As String = "UserDefinedText"

   Public Event MultiplexerControlChanged(Name As String)   'Ruft in PCA 'DataLoggerMuxChanged()' auf

   'Sobald der Benutzer einen Controleintrag verändert wird 'bUserChangedControlSettings' = TRUE.   
   Public Property pbUserChangedControlSettings() As Boolean
      Get
         pbUserChangedControlSettings = bUserChangedControlSettings
      End Get
      Set(ByVal bValue As Boolean)
         Call ShowAsterisk(bValue)
      End Set
   End Property

   'Die Beschriftung des EINGEKLAPPTEN 'chk_ExpandControl' wird nicht aus der 'cbo_MultiplexerChoiceBox' abgeleitet,
   'die Beschriftung des AUSGEKLAPTEN  'chk_ExpandControl' wird nicht von 'sControlName' abgeleitet,
   'sondern es wird IMMER die extern mittels 'psUserDefindedMarkingForchk_ExpandControl_Text' übergebene Beschriftung angezeigt.
   <DefaultValue(False), _
      Description("")> _
   Public Property pbUseUserDefindedMarkingForchk_ExpandControl_Text As Boolean
      Get
         Return bUseUserDefindedMarkingForchk_ExpandControl_Text
      End Get
      Set(ByVal bValue As Boolean)
         bUseUserDefindedMarkingForchk_ExpandControl_Text = bValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'Die Beschriftung des EINGEKLAPPTEN 'chk_ExpandControl' wird nicht aus der 'cbo_MultiplexerChoiceBox' abgeleitet,
   'die Beschriftung des AUSGEKLAPTEN  'chk_ExpandControl' wird nicht von 'sControlName' abgeleitet,
   'sondern es wird IMMER die extern mittels 'psUserDefindedMarkingForchk_ExpandControl_Text' übergebene Beschriftung angezeigt.
   'wenn 'pbUseUserDefindedMarkingForchk_ExpandControl_Text = TRUE' ist.
   <DefaultValue("UserDefinedText"), _
      Description("")> _
   Public Property psUserDefindedMarkingForchk_ExpandControl_Text As String
      Get
         Return sUserDefindedMarkingForchk_ExpandControl_Text
      End Get
      Set(ByVal sValue As String)
         sUserDefindedMarkingForchk_ExpandControl_Text = sValue
      End Set
   End Property

   'Name des Controls, wird angezeigt, wenn mit 'pbExpandControlButtonVisible = TRUE' 'chk_ExpandControl' sichtbar und AUSgeklappt ist,
   'sofern 'pbUseUserDefindedMarkingForchk_ExpandControl_Text = FALSE' ist. Sonst wird 'psUserDefindedMarkingForchk_ExpandControl_Text' angezeigt.
   'Ist das MuxControl mit sichtbarem 'chk_ExpandControl' EINgeklappt wird darauf abhängig von 'pbUseUserDefindedMarkingForchk_ExpandControl_Text'
   'entweder die selektierte Auswahl aus 'cbo_MultiplexerChoiceBox' oder 'psUserDefindedMarkingForchk_ExpandControl_Text' angezeigt.
   Public Property psControlName As String
      Get
         Return sControlName
      End Get
      Set(ByVal sValue As String)
         sControlName = sValue
         'evtl. vorhandenes *" erhalten
         Dim iIndexOf As Integer = chk_ExpandControl.Text.IndexOf("*")
         If iIndexOf = 0 Then
            chk_ExpandControl.Text = "*" & sControlName
         Else
            chk_ExpandControl.Text = sControlName
         End If
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'Ist der Wert aktiv (true) wird der der Ausgangswert des Controls anstelle des Control-Namens angezeigt.
   <DefaultValue(False), _
      Description("")> _
   Public Property pbLiveViewEnabled As Boolean
      Get
         Return bLiveViewEnabled
      End Get
      Set(ByVal bValue As Boolean)
         bLiveViewEnabled = bValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'Setzt den ToolTip für den ControlSwitch
   <DefaultValue("ToolTip for ControlSwitch"), _
      Description("Setzt den ToolTip für den ControlSwitch")> _
   Public WriteOnly Property psToolTip As String
      Set(ByVal sToolTipText As String)
         ToolTip_MuxControl.SetToolTip(Me.chk_ExpandControl, sToolTipText)
      End Set
   End Property

   'Ueberschreibt die Standardbreite des Controls im eingeklappten Zustand
   Public Property piExpandControlButtonSizeWidthWhenControlNOTExpanded As Integer
      Get
         Return iExpandControlButtonSizeWidthWhenControlNOTExpanded
      End Get
      Set(ByVal iValue As Integer)
         iExpandControlButtonSizeWidthWhenControlNOTExpanded = iValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'Ueberschreibt die Standardbreite des Controls im ausgeklappten Zustand
   Public Property piControlLargeWidth As Integer
      Get
         Return iControlSizeWidthWhenControlExpanded
      End Get
      Set(ByVal iValue As Integer)
         iControlSizeWidthWhenControlExpanded = iValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'Der uebergebene Wert wird im Control anstelle des Control-Namen angezeigt, sofern die "bLiveViewEnabled" Funktion aktiviert ist
   <DefaultValue(0.0R), _
     Description("")> _
   Public Property pdValueToBeShownInLiveView As Double
      Get
         Return dControlOutputValue
      End Get
      Set(ByVal dValue As Double)
         dControlOutputValue = dValue
      End Set
   End Property

   'Public Property pNameAtDisable As String
   '   Get
   '      Return sNameAtDisable
   '   End Get
   '   Set(ByVal sValue As String)
   '      sNameAtDisable = sValue
   '   End Set
   'End Property

   'die Auswahlpunkte des Multiplexers "mit Leben" füllen
   'Mit einem Set-Aufruf wird die "ComboBox.ObjectCollection" direkt angesprochen und minpuliert.
   'D.h. .pcboMuxItems.Clear() löscht den gesamten Inhalt der "ComboBox.ObjectCollection".
   '     .pcboMuxItems.Add()   fügt eine Element in die "ComboBox.ObjectCollection" hinzu usw.
   Public Property pcboMuxItems As System.Windows.Forms.ComboBox.ObjectCollection
      Get
         Return cbo_MultiplexerChoiceBox.Items
      End Get
      Set(ByVal Value As System.Windows.Forms.ComboBox.ObjectCollection)   'ComboBox.ObjectCollection editieren und anschliessend in die eigentlich ComboBox übertragen
         cbo_MultiplexerChoiceBox.Items.Clear()                            'Entfernt alle Elemente aus ComboBox 
         Dim objMuxArray(cbo_MultiplexerChoiceBox.Items.Count - 1) As Object  'Größe des Objektarray festlegen, in das die Auflistung kopiert werden soll
         Value.CopyTo(objMuxArray, 0)                                         'Kopiert die gesamte Auflistung an eine angegebene Position in ein vorhandenes Array von Objekten.
         cbo_MultiplexerChoiceBox.Items.AddRange(objMuxArray)                 'Fügt der Liste von Elementen für eine ComboBox ein Array von Elementen hinzu
      End Set
   End Property

   'setzt den Multiplexer auf den entsprechenden Auswahlpunkt, bzw. liefert den Index des Auswahlpunktes zurueck
   'numerisch
   <DefaultValue(0), _
  Description("")> _
   Public Property piMuxSelectedIndex As Integer
      Get
         Return cbo_MultiplexerChoiceBox.SelectedIndex   'Ruft den Index des derzeit ausgewählten Elements ab.
      End Get
      Set(ByVal iValue As Integer)
         cbo_MultiplexerChoiceBox.SelectedIndex = iValue  'Legt den Index des derzeit ausgewählten Elements fest.
      End Set
   End Property

   'setzt den Multiplexer auf den entprechenden Auswahlpunkt, bzw. liefert den Auswahlpunktes des Index als Text zurueck
   <DefaultValue("Multiplexer disabled"), _
   Description("")> _
   Public Property psMuxSelectedItem As String
      Get
         Return CStr(cbo_MultiplexerChoiceBox.SelectedItem)    'Ruft das derzeit ausgewählte Element in ComboBox ab. 
      End Get
      Set(ByVal sValue As String)
         cbo_MultiplexerChoiceBox.SelectedItem = sValue   'Legt das derzeit ausgewählte Element in ComboBox fest. 
      End Set
   End Property

   'zum Ein- und Ausklappen des Controls
   <DefaultValue(False), _
   Description("Ausklappen (True) oder einklappen (False) des Controls")> _
   Public Property pbchk_ExpandControl As Boolean
      Get
         Return chk_ExpandControl.Checked
      End Get
      Set(ByVal bValue As Boolean)
         chk_ExpandControl.Checked = bValue
      End Set
   End Property

   'anzeigen, oder nicht anzeigen des 'ControlSwitch'
   <DefaultValue(True), _
   Description("ControlSwitch ist verfügbar (True) - Control kann aus- und eingeklappt werden. Bei False ist Control immer ausgeklappt und ControlSwitch ist nciht verfügbar.")> _
   Public Property pbExpandControlButtonVisible As Boolean
      Get
         Return chk_ExpandControl.Visible
      End Get
      Set(ByVal bValue As Boolean)
         chk_ExpandControl.Visible = bValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'anzeigen, oder nicht anzeigen der 'Invert' Checkbox
   <DefaultValue(True), _
   Description("Inversions-Checkbox ist verfügbar bei True.")> _
   Public Property pbInvertedOutputCheckBoxVisible As Boolean
      Get
         Return chk_InvertOutput.Visible
      End Get
      Set(ByVal bValue As Boolean)
         chk_InvertOutput.Visible = bValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'Checkbox 'Invert' setzten, bzw. deren Zustand liefern
   <DefaultValue(False), _
   Description("Inversions-Checkbox ist NICHT gesetzt bei False.")> _
   Public Property pbInvertedOutput As Boolean
      Get
         Return chk_InvertOutput.Checked
      End Get
      Set(ByVal bValue As Boolean)
         chk_InvertOutput.Checked = bValue
      End Set
   End Property

   'Aufgabe dieser Property ist im "frm_MFU.." beschrieben.
   <DefaultValue(False), _
   Description("Die Auswahl des Mux wurde irgendwie verändert.")> _
   Public ReadOnly Property pbSomehowSelectionChanged As Boolean
      Get
         Return bSomehowSelectionChanged
      End Get

   End Property

   'Initialiserung des Controls
   Private Sub LoadThisControl_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

      If bFormLoaded = False Then

         Call ChangeCulture()
         chk_ExpandControl.Text = sControlName

         Call ToolTip()

         cbo_MultiplexerChoiceBox.BackColor = FriendGlobal_UnchangedBackColor     'Hintergrundfarben der Auswahliste und der 'Invert' Checkbox auf "nichts geaendert"
         chk_InvertOutput.BackColor = FriendGlobal_UnchangedBackColor

         If cbo_MultiplexerChoiceBox.Items.Count > 0 Then            'besitzt das Control Auswahlpunkte -> den Index auf den ersten setzten
            cbo_MultiplexerChoiceBox.SelectedIndex = 0
         End If

         chk_ExpandControl.Checked = False                           'Control eingeklappt
         chk_InvertOutput.Checked = False                            'Invert-Checkbox abschalten
         chk_ExpandControl_DoWork()                                  'Klappaktionen usw. druchfuehren

         ToolTip_MuxControl.SetToolTip(Me.chk_ExpandControl, "ToolTip for ControlSwitch")

         ChangeAllFieldBackColorsToUnchangedFieldContent()

         bFormLoaded = True

      End If

   End Sub
   'Tooltips des Controls
   Private Sub ToolTip()

      ToolTip_MuxControl.SetToolTip(Me.chk_ExpandControl, "ToolTip for ControlSwitch")
      ToolTip_MuxControl.SetToolTip(Me.cbo_MultiplexerChoiceBox, "List of available inputs")
      ToolTip_MuxControl.SetToolTip(Me.chk_InvertOutput, "It inverts the output (from 0 to 1 and viceversa)")

   End Sub

   'Zeigt bei Änderunegen durch den Nutzer dies mit einem kleinen "*" an
   'Diese Sternchen steht am Anfang des 'chk_ExpandControl.Text'
   Friend Sub ShowAsterisk(bShowIt As Boolean)

      'chk_ExpandControl.Text' testen ob am Anfang schon ein '*' steht, wenn nein -> ggf. eins hinsetzen
      Dim iIndexOf As Integer = chk_ExpandControl.Text.IndexOf("*")

      bUserChangedControlSettings = bShowIt   'wird über Public Properties gelöscht

      '"*" muss an erster Stelle, also Index = 0 stehen
      'Gibt's kein "*"* ist 'IndexOf' = -1
      If iIndexOf = 0 And bShowIt = False Then  'evtl. nix tun, "*" wird schon angezeigt, es sei denn es soll entfernt werden

         chk_ExpandControl.Text = chk_ExpandControl.Text.Remove(0, 1)

      ElseIf iIndexOf < 0 And bShowIt = True Then  '"*" anzeigen, also an Anfang von .Text setzen

         chk_ExpandControl.Text = "*" & chk_ExpandControl.Text
         RaiseEvent UserChangedControlSettings(ParentForm, bShowIt)

      Else  'es gibt ein "*" in .Text, aber nicht an erster Stelle, also ignorieren

      End If

   End Sub

   'wird in einem der Steuerelemente von "Handles' ein Wert geaendert, wird die Hintergrundfarbe des Steuerelements geaendert
   Private Sub cbo_MultiplexerChoiceBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbo_MultiplexerChoiceBox.SelectedIndexChanged

      If bFormLoaded = True Then
         cbo_MultiplexerChoiceBox.BackColor = FriendGlobal_ChangedBackColor
         bSomehowSelectionChanged = True
         Call ShowAsterisk(True)

         chk_ExpandControl_DoWork()

         RaiseEvent MultiplexerControlChanged(Me.Name)   'ruft in PCA 'DataLoggerMuxChanged' auf

         Me.Invalidate()

      End If

   End Sub

   'wird in einem der Steuerelemente von "Handles' ein Wert geaendert, wird die Hintergrundfarbe des Steuerelements geaendert
   Private Sub chk_Invert_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_InvertOutput.CheckedChanged

      If bFormLoaded = True Then

         If chk_InvertOutput.Checked = True Then
            chk_InvertOutput.BackColor = FriendGlobal_ColorWarning
         Else
            chk_InvertOutput.BackColor = FriendGlobal_UnchangedBackColor
         End If

         bSomehowSelectionChanged = True

         Call ShowAsterisk(True)

         chk_ExpandControl_DoWork()

         RaiseEvent MultiplexerControlChanged(Me.Name)   'ruft in PCA 'DataLoggerMuxChanged' auf

         Me.Invalidate()

      End If

   End Sub

   'setzt die Hintergrundfarben des Steuerelemente zurueck
   Public Sub ChangeAllFieldBackColorsToUnchangedFieldContent()

      'Das eigene "*" löschen.
      Call ShowAsterisk(False)

      'Die Hintergrundfarbe der eigenen Controls zurücksetzen.
      Call mod_Functions_ChangeTextBoxesComboBoxesCheckBoxesBackToUnchanged(Me)

      bSomehowSelectionChanged = False

   End Sub

   Private Sub chk_ExpandControl_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chk_ExpandControl.CheckedChanged
      Call chk_ExpandControl_DoWork()
   End Sub

   'Control ausgeklappt (ControlSwitch.Checked = True) oder nicht

   'Das Control kann folgende Zustände annehmen:
   'Der 'ControlSwitch' ist verfügbar       (visible = TRUE) , das Control kann über diesen ein- und ausgeklappt werden.
   '  - mit checked = TRUE    ist das Control AUSgeklappt
   '  - mit checked = FALSE   ist das Control EINgeklappt

   'Der 'ControlSwitch' ist NICHT verfügbar (visible = FALSE), das Control ist immer ausgeklappt, der 'ControlSwitch' wird NICHT angezeigt.

   Public Sub chk_ExpandControl_DoWork()

      Dim sTempDisplayString As String
      Dim sTempAsterisk As String = ""

      'Testen ob am Anfang der 'chk_ExpandControl_DoWork.Text' Beschriftung ein "*" steht.
      'Wenn JA muss dieses auch dort bleiben.
      If chk_ExpandControl.Text <> "" Then
         If chk_ExpandControl.Text.Substring(0, 1) = "*" Then
            sTempAsterisk = "*"
         End If
      End If

      If chk_InvertOutput.Visible = True Then       'Wird die Invertierungsfunktion des Multiplexers unterstuetzt...

         If chk_InvertOutput.Checked = True Then    '... und ist ist 'Invertieren' aktiv...
            chk_ExpandControl.Font = New Drawing.Font("Microsoft Sans Serif", 8.25, Drawing.FontStyle.Underline)   '...wird die Beschriftung des 'ControlSwitch' unterstrichen...
         Else
            chk_ExpandControl.Font = New Drawing.Font("Microsoft Sans Serif", 8.25, Drawing.FontStyle.Regular)     '...andernfalls nicht.
         End If

         cbo_MultiplexerChoiceBox.Width = iControlSizeWidthWhenControlExpanded - 55   'Breite der "Multiplexer-Auflistungs-Auswahlliste" reduzieren um Inversions-Checkbox daneben anzuzeigen
         chk_InvertOutput.Left = iControlSizeWidthWhenControlExpanded - 48

      Else
         'NOTE!!: The line below is commented because of the following VisualStudio problem:
         '        During the save procedure, if the refreshing action is active, the chk_Invert visibility is lost.
         '        This missbehavior is visible only when the mux controller is implemented in a tab page different 
         '        from the first one!!.
         '     
         '        The position of the tab page where the multiplexer controller is implemented affects also 
         '        the controller button displayed size.

         'chk_Invert.Checked = False                                  'Invertierfunktion wird fuer diesen Mutiplexer NICHT unterstuetzt
         chk_ExpandControl.Font = New Drawing.Font("Microsoft Sans Serif", 8.25, Drawing.FontStyle.Regular)        'Beschriftung des 'ControlSwitch' ist NIE unterstrichen
         cbo_MultiplexerChoiceBox.Width = iControlSizeWidthWhenControlExpanded - 8      'Breite der "Multiplexer-Auflistungs-Auswahlliste"

      End If

      '--------------------------------------------------------------------------------------------------
      If chk_ExpandControl.Visible = True Then                       'Der ControlSwitch ist verfügbar

         'Die Mux-Auswahlbox und die Inversions-Checkbox werden unterhalb des 'ControlSwitch' dargstellt.

         cbo_MultiplexerChoiceBox.Top = 31                           'Position der "Multiplexer-Auflistungs-Auswahlliste" innerhalb des Mux-Form
         chk_InvertOutput.Top = 32                                   'Position der "Invert_Checkbox" innerhalb des Mux-Form

         If chk_ExpandControl.Checked = True Then                    'Das Control ist AUSgeklappt.

            chk_ExpandControl.Height = ciExpandControlButtonSizeHeightWhenControlExpanded    'Hoehe des Button zum Einklappen des Controls (i.d.R. = Hoehe des Button bei eingeklapptem Control)
            chk_ExpandControl.Width = iControlSizeWidthWhenControlExpanded - 2               'Breite des Button zum Einklappen des Controls (i.d.R. = Breite des ausgeklapptem Control)
            Me.Height = ciControlSizeHeightWhenControlExpanded                               'Hoehe des Control (ausgeklappt)
            Me.Width = iControlSizeWidthWhenControlExpanded                                  'Breite des Control (ausgeklappt)
            Me.BorderStyle = Windows.Forms.BorderStyle.FixedSingle      'Rahmen des ausgeklappten Control hat eine einfache Linie
            Me.BringToFront()                                           'Control nach vorne an den Anfang der z-Reihenfolge

            If bUseUserDefindedMarkingForchk_ExpandControl_Text = False Then
               sTempDisplayString = sControlName
            Else
               sTempDisplayString = sUserDefindedMarkingForchk_ExpandControl_Text
            End If

         Else                                                        'Das Control ist EINgeklappt.

            chk_ExpandControl.Height = ciExpandControlButtonSizeHeightWhenControlNOTExpanded 'Hoehe des Button zum Ausklappen des Controls (i.d.R. = Hoehe des Button bei ausgeklapptem Control)
            chk_ExpandControl.Width = iExpandControlButtonSizeWidthWhenControlNOTExpanded    'Breite des Button zum ausklappen des Controls (i.d.R. = Breite des eingeklapptem Control)
            Me.Height = ciExpandControlButtonSizeHeightWhenControlNOTExpanded                'Hoehe des Control (eingeklappt), nur Button
            Me.Width = iExpandControlButtonSizeWidthWhenControlNOTExpanded                   'Breite des Control (eingeklappt), nur Button
            Me.BorderStyle = Windows.Forms.BorderStyle.None                                  'kein Rahmen bei eingeklapptem Control
            Me.SendToBack()

            If bUseUserDefindedMarkingForchk_ExpandControl_Text = False Then
               sTempDisplayString = cbo_MultiplexerChoiceBox.Text
            Else
               sTempDisplayString = sUserDefindedMarkingForchk_ExpandControl_Text
            End If

         End If

         If bLiveViewEnabled = True Then                           'Ausgangswert des Multiplexers anstelle des Control-Namen auf dem 'ControlSwitch' anzeigen

            chk_ExpandControl.Text = sTempAsterisk & "Val=" & Format(dControlOutputValue, csStandardFormatForVoltagesInLiveView & "V")

            If dControlOutputValue < 0 Then                          'Ausgangswert ist negativ...
               chk_ExpandControl.ForeColor = Drawing.Color.Blue      '...Farbe auf blau...
            Else
               chk_ExpandControl.ForeColor = Drawing.Color.Black     '...andernfalls auf schwarz
            End If

         Else

            chk_ExpandControl.Text = sTempAsterisk & sTempDisplayString               'Anzeige des 'Control-Namen'
            chk_ExpandControl.ForeColor = Drawing.Color.Black        'Schrift auf schwarz

         End If

      '--------------------------------------------------------------------------------------------------
      Else                                                           'Der ControlSwitch ist NICHT verfügbar

         'Die Mux-Auswalbox und die Inversions-Checkbox werden anstelle des 'ControlSwitch' dargstellt.

         cbo_MultiplexerChoiceBox.Top = 2                            'Position der "Multiplexer-Auflistungs-Auswahlliste" innerhalb des Mux-Form
         chk_InvertOutput.Top = 3                                          'Position der "Invert_Checkbox" innerhalb des Mux-Form

         Me.Height = ciExpandControlButtonSizeHeightWhenControlNOTExpanded          'Hoehe des Control (eingeklappt), nur Button
         Me.Width = iControlSizeWidthWhenControlExpanded                            'Breite des Control (ausgeklappt)
         Me.BorderStyle = Windows.Forms.BorderStyle.None             'kein Rahmen

      End If

      'Aus welchem Grund auch immer rutscht das MuxControl beim zuklappen in den Hintergrund, sofern .pbExpandControlButtonVisible = True
      'und das Control vor z.B. einem Label platziert ist.
      'Nachfolgendes bringt das Control immer in den Vordergrund.
      Me.BringToFront()

   End Sub

   'gibt die Position (den Index) innnerhalb der "Multiplexer-Auflistungs-Auswahlliste" als Hex-Wert zurueck
   Public Function f_sMuxSelectedIndexAsHexValue() As String

      Dim sTempString As String

      If cbo_MultiplexerChoiceBox.SelectedIndex >= 0 And cbo_MultiplexerChoiceBox.SelectedIndex <= 15 Then
         sTempString = ConvertLongToHexString(CLng(cbo_MultiplexerChoiceBox.SelectedIndex), 1)
      Else
         sTempString = "0"     'wenn kein Index gewählt wurde wird der Wert 0 ausgegeben 
      End If

      f_sMuxSelectedIndexAsHexValue = sTempString

   End Function

End Class
