﻿Option Strict On

Imports System.Windows.Forms
Imports System.ComponentModel

   '23.03.21   Die Änderung im 'WaterMeasurementControl' für PCA 7.7.0 ('tbo_MinFLowRate' = 0 => fCalcMinFlowTime = "7FFFFF", bzw 'tbo_MaxFlowRate' = 0 => fCalcMaxFlowTime = "800000" und nicht
   '           mehr "000000") sorgte dafür, dass normale Interlocks mit diesem Modul nicht mehr erkannt werden konnten, da die Kompartorschwellen auf Min/Max stehen. Um normale Interlocks
   '           erkennen zu können müssen diese aber beide 0 sein! (DS)

Public Class WaterMeasurementControl_7_0

   'Dieses Ereignis signalisiert, dass an dieser Instanz des ACU-Controls seitens des Benutzers eine Eingabe/Änderung durchgeführt wurde.
   'Es wird 1-lig ausgelöst, wenn das '*' im Conrol Namen gesetzt wird.
   Public Event UserChangedControlSettings(frmParentForm As Form, bShowIt As Boolean)

   'Dieses Ereignis signalisiert, dass an dieser Instanz des ACU-Controls seitens des Benutzers eine Eingabe/Änderung durchgeführt wurde.
   'Es wird jedes Mal ausgelöst, wenn eine Änderung statt findet.
   Public Event UserChangedControlSettingsRepetitive(sender As System.Object, e As System.EventArgs)

   Const csStandardFormatForFlowRateInLiters As String = "0.00"        ' Format für die Zahlendarstellungen 
   Const csStandardFormatForPulsesPerLiters As String = "0"
   Const csStandardFormatForVoltagesInLiveView As String = "0.00"

   Const ciControlSizeWidthWhenControlExpanded As Integer = 215

   Const ciExpandControlButtonSizeHeightWhenControlExpanded As Integer = 25
   Const ciExpandControlButtonSizeHeightWhenControlNOTExpanded As Integer = 25
   Const ciExpandControlButtonSizeWidthWhenControlNOTExpanded As Integer = 215

   Dim dLSBValue As Double = 22 / ((2 ^ 32) - 1)

   Const ciControlSizeHeightWhenControlExpandedFloatTypeOrNormInterlock = 60
   Const ciControlSizeHeightWhenControlExpanded = 140

   Dim iControlSizeHeightWhenControlExpanded As Integer

   Dim dWaterFlow_LitersPerMin_MaxVal As Double    'Maximalwert
   Dim dWaterFlow_LitersPerMin_MinVal As Double    'Minimalwert

   Dim bFormLoaded As Boolean = False

   Dim dValueToBeShownInLiveView As Double
   Dim bLiveViewEnabled As Boolean
   Dim sControlName As String = "Water meassurement"

   Const srtFloatTypeOrNormInterlock_MaxVal As Short = 0
   Const srtCustomized_Values_MaxVal As Short = 0
   Const srtRRI_010XXX020_2l_MaxVal As Short = &HCC3
   Const srtRRI_010XXX050_12l_MaxVal As Short = &H5D6
   Const srtRRI_010XXX070_14l_MaxVal As Short = &H946
   Const srtRRI_025XXX080_36l_MaxVal As Short = &H55A
   Const srtRRI_025XXX120_72l_MaxVal As Short = &H55C
   Const srtRRI_025XXX160_120l_MaxVal As Short = &H7C0
   Const srtDRS_9250XXF300_MaxVal As Short = &HA2C



   Const srtFloatTypeOrNormInterlock_MinVal As Short = 0
   Const srtCustomized_Values_MinVal As Short = 0
   Const srtRRI_010XXX020_2l_MinVal As Short = &H72E3
   Const srtRRI_010XXX050_12l_MinVal As Short = &H74C7
   Const srtRRI_010XXX070_14l_MinVal As Short = &H7968
   Const srtRRI_025XXX080_36l_MinVal As Short = &H7876
   Const srtRRI_025XXX120_72l_MinVal As Short = &H7C8E
   Const srtRRI_025XXX160_120l_MinVal As Short = &H7F67
   Const srtDRS_9250XXF300_MinVal As Short = &H7F28


   Dim bUserChangedControlSettings As Boolean = False

   Enum eFlowMeterType
      Float_Type_or_norm_Interlock = 0
      Customized_Values = 1
      RRI_010XXX020_2l = 2
      RRI_010XXX050_12l = 3
      RRI_010XXX070_14l = 4
      RRI_025XXX080_36l = 5
      RRI_025XXX120_72l = 6
      RRI_025XXX160_120l = 7
      DRS_9250XXF300 = 8
   End Enum

   ' Allgemeine Propertys des Moduls

   'pbUserChangedControlSettings(): Sobald der Benutzer einen Controleintrag verändert wird 'bUserChangedControlSettings' = TRUE.   
   Public Property pbUserChangedControlSettings() As Boolean
      Get
         pbUserChangedControlSettings = bUserChangedControlSettings
      End Get
      Set(ByVal bValue As Boolean)
         Call ShowAsterisk(bValue)
      End Set
   End Property

   'psControlName(): Beschriftungstext des Controls
   Public Property psControlName As String
       Get
         Return sControlName
      End Get
      Set(ByVal sValue As String)
         sControlName = sValue
         'evtl. vorhandenes *" erhalten
         Dim iIndexOf As Integer = chk_ExpandControl.Text.IndexOf("*")
         If iIndexOf = 0 Then
            chk_ExpandControl.Text = "*" & sControlName
         Else
            chk_ExpandControl.Text = sControlName
         End If
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'pbLiveViewEnabled(): Ist der Wert aktiv (true) wird der der Ausgangswert des Controls anstelle des Control-Namens angezeigt.  
   Public Property pbLiveViewEnabled As Boolean
      Get
         Return bLiveViewEnabled
      End Get
      Set(ByVal bValue As Boolean)
         bLiveViewEnabled = bValue
         Call chk_ExpandControl_DoWork()
      End Set
   End Property

   'psToolTip(): Setzt den ToolTip für den ControlSwitch   
   Public WriteOnly Property psToolTip As String
      Set(ByVal sToolTipText As String)
         ToolTip.SetToolTip(Me.chk_ExpandControl, sToolTipText)
      End Set
   End Property

   Public Property pdValueToBeShownInLiveView As Double
      Get
         Return dValueToBeShownInLiveView
      End Get
      Set(ByVal dValue As Double)
         dValueToBeShownInLiveView = dValue
      End Set
   End Property

   'pdLSBValue(): Wert für das LSB der Umrechung von Long nach Double, DefaultValue((22 / ((2 ^ 32) - 1)))
   Public Property pdLSBValue As Double
      Get
         Return dLSBValue
      End Get
      Set(ByVal dValue As Double)
         dLSBValue = dValue
      End Set
   End Property

   'pdFlowRate_LitersPerMin_MaxVal():
   Public Property pdFlowRate_LitersPerMin_MaxVal As Double
      Get
         Return ConvertStringToDouble(lbl_FlowRate_LitersPerMin_MaxVal.Text)
      End Get
      Set(ByVal dValue As Double)
         lbl_FlowRate_LitersPerMin_MaxVal.Text = dValue.ToString(csStandardFormatForFlowRateInLiters)
         Call UpdateToolTip()
      End Set
   End Property

   'pdFlowRate_LitersPerMin_MinVal():
   Public Property pdFlowRate_LitersPerMin_MinVal As Double
      Get
         Return ConvertStringToDouble(tbo_FlowRate_LitersPerMin_MinVal.Text)
      End Get
      Set(ByVal dValue As Double)
         tbo_FlowRate_LitersPerMin_MinVal.Text = dValue.ToString(csStandardFormatForFlowRateInLiters)
         Call UpdateToolTip()
      End Set
   End Property

   'pbchk_ExpandControl(): zum Ein- und Ausklappen des Controls
   Public Property pbchk_ExpandControl As Boolean
      Get
         Return chk_ExpandControl.Checked
      End Get
      Set(ByVal bValue As Boolean)
         chk_ExpandControl.Checked = bValue
      End Set
   End Property

   'pbExpandControlPossible(): Wenn der Wert auf false ist kann das Control NICHT ausgeklappt werden
   Public Property pbExpandControlPossible As Boolean
      Get
         Return chk_ExpandControl.Enabled
      End Get
      Set(ByVal bValue As Boolean)
         chk_ExpandControl.Enabled = bValue
      End Set
   End Property

   'pdPulsesPerLiter():
   Public Property pdPulsesPerLiter As Double
      Get
         Return ConvertStringToDouble(tbo_PulsesPerLiter.Text)
      End Get
      Set(ByVal dValue As Double)
         tbo_PulsesPerLiter.Text = dValue.ToString(csStandardFormatForPulsesPerLiters)
         Call UpdateToolTip()
      End Set
   End Property

   'piWaterFlowMeterType()
   Public Property piWaterFlowMeterType As Integer
      Get
         Return cbo_WaterflowmeterType.SelectedIndex
      End Get
      Set(ByVal iValue As Integer)

         If iValue <= (cbo_WaterflowmeterType.Items.Count) - 1 Then
            cbo_WaterflowmeterType.SelectedIndex = iValue
         Else
            cbo_WaterflowmeterType.SelectedIndex = 0
         End If

         Call UpdateToolTip()

      End Set
   End Property

   'LoadThisControl_Load():
   Private Sub LoadThisControl_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

      If bFormLoaded = False Then

         Call ChangeCulture()

         cbo_WaterflowmeterType.Items.Clear()

         For Each enumValue As Integer In [Enum].GetValues(GetType(eFlowMeterType))
            cbo_WaterflowmeterType.Items.Add([Enum].GetName(GetType(eFlowMeterType), enumValue))
         Next

         chk_ExpandControl.Checked = False
         chk_ExpandControl_DoWork()

         'ControlSwitchToSmall()

         'Steht ein Wert in der TextBox z.B. "1,2", dann
         '1. ggf. '.' durch ',' ersetzen (. ist 1000er Trennzeichen bei Format Funktion)
         '2. den String nach Double konvertieren
         '3. Double wieder in String formatieren
         'ist der String "", wird das Ergebnis 0 im Format des StandardFormats

         lbl_FlowRate_LitersPerMin_MaxVal.Text = Convert.ToDouble(lbl_FlowRate_LitersPerMin_MaxVal.Text.Replace(".", ",")).ToString(csStandardFormatForFlowRateInLiters) 'Replace(csStandardFormatForFlowRateInLiters, ".", ",")
         tbo_FlowRate_LitersPerMin_MinVal.Text = Convert.ToDouble(tbo_FlowRate_LitersPerMin_MinVal.Text.Replace(".", ",")).ToString(csStandardFormatForFlowRateInLiters) 'Replace(csStandardFormatForFlowRateInLiters, ".", ",")
         tbo_PulsesPerLiter.Text = Convert.ToDouble(tbo_PulsesPerLiter.Text.Replace(".", ",")).ToString(csStandardFormatForPulsesPerLiters) 'Replace(csStandardFormatForPulsesPerLiters, ".", ",")
         lbl_FlowRate_LitersPerMin_MaxVal.BackColor = FriendGlobal_UnchangedBackColor
         tbo_FlowRate_LitersPerMin_MinVal.BackColor = FriendGlobal_UnchangedBackColor
         tbo_PulsesPerLiter.BackColor = FriendGlobal_UnchangedBackColor

         cbo_WaterflowmeterType.SelectedIndex = 0
         cbo_WaterflowmeterType.BackColor = FriendGlobal_UnchangedBackColor

         If dLSBValue = 0 Then                  ' Sollte die LSB Variable auf 0 gesetzt sein wird diese hier wieder mit dem 32Bit Wert vorgeladen.
            dLSBValue = 22 / ((2 ^ 32) - 1)
         End If

         Call UpdateToolTip()

         bFormLoaded = True

      End If

   End Sub

   'UpdateToolTip():
   Private Sub UpdateToolTip()

      ToolTip.SetToolTip(Me.chk_ExpandControl, "This button opens and closes the WaterMeasurementControl." & CrLf & _
                                               "The module is currently parameterized as follows:" & CrLf & _
                                               "Type: " & cbo_WaterflowmeterType.Text & CrLf & _
                                               "Pulses/Liter: " & tbo_PulsesPerLiter.Text & CrLf & _
                                               "max. flow rate: " & lbl_FlowRate_LitersPerMin_MaxVal.Text & CrLf & _
                                               "min. flow rate: " & tbo_FlowRate_LitersPerMin_MinVal.Text)

   End Sub

   'ChangeAllFieldBackColorsToUnchangedFieldContent(): setzt die Hintergrundfarben des Steuerelemente zurueck
   Public Sub ChangeAllFieldBackColorsToUnchangedFieldContent()

      'Das eigene "*" löschen.
      Call ShowAsterisk(False)

      'Die Hintergrundfarbe der eigenen Controls zurücksetzen.
      Call mod_Functions_ChangeTextBoxesComboBoxesCheckBoxesBackToUnchanged(Me)

   End Sub

   'ShowAsterisk(): Zeigt bei Änderunegen durch den Nutzer dies mit einem kleinen "*" an
   '                Diese Sternchen steht am Anfang des 'chk_ExpandControl.Text'
   Private Sub ShowAsterisk(bShowIt As Boolean)

      RaiseEvent UserChangedControlSettingsRepetitive(Me, EventArgs.Empty)

      'chk_ExpandControl.Text' testen ob am Anfang schon ein '*' steht, wenn nein -> ggf. eins hinsetzen
      Dim iIndexOf As Integer = chk_ExpandControl.Text.IndexOf("*")

      bUserChangedControlSettings = bShowIt   'wird über Public Properties gelöscht

      '"*" muss an erster Stelle, also Index = 0 stehen
      'Gibt's kein "*"* ist 'IndexOf' = -1
      If iIndexOf = 0 And bShowIt = False Then  'evtl. nix tun, "*" wird schon angezeigt, es sei denn es soll entfernt werden

         chk_ExpandControl.Text = chk_ExpandControl.Text.Remove(0, 1)

      ElseIf iIndexOf < 0 And bShowIt = True Then  '"*" anzeigen, also an Anfang von .Text setzen

         chk_ExpandControl.Text = "*" & chk_ExpandControl.Text
         RaiseEvent UserChangedControlSettings(ParentForm, bShowIt)

      Else  'es gibt ein "*" in .Text, aber nicht an erster Stelle, also ignorieren

      End If

   End Sub

   'tbo_PulsesPerLiter_Leave(): Wird die TextBox von 'Handle' verlassen, testen ob der eingetragene Inhalt zulaessig ist
   Private Sub tbo_PulsesPerLiter_Leave(sender As System.Object, e As System.EventArgs) Handles tbo_PulsesPerLiter.Leave

      If bFormLoaded = True Then

         Dim sTextBoxName As String = mod_Functions_StringRight(tbo_PulsesPerLiter.Name, (tbo_PulsesPerLiter.Name.Length - 4))

         tbo_PulsesPerLiter.Text = CheckAndFormatValue(tbo_PulsesPerLiter.Text, _
                                                       20000, _
                                                       0, _
                                                       "The """ & sTextBoxName & """ value must not", "Pulse/liter", _
                                                       csStandardFormatForPulsesPerLiters, _
                                                       sControlName & "-" & sTextBoxName)
      End If

   End Sub

   'tbo_FlowRate_LitersPerMin_MinVal_Leave(): Wird die TextBox von 'Handle' verlassen, testen ob der eingetragene Inhalt zulaessig ist
   Private Sub tbo_FlowRate_LitersPerMin_MinVal_Leave(sender As System.Object, e As System.EventArgs) Handles tbo_FlowRate_LitersPerMin_MinVal.Leave

      If bFormLoaded = True Then

         Dim sTextBoxName As String = mod_Functions_StringRight(tbo_FlowRate_LitersPerMin_MinVal.Name, (tbo_FlowRate_LitersPerMin_MinVal.Name.Length - 4))

         'Friend Function CheckAndFormatValue(Text As String,
         '                                    MaxValue As Double,
         '                                    MinValue As Double,
         '                                    Optional ErrorText As String = "The value must not",
         '                                    Optional Unit As String = "V",
         '                                    Optional NumberFormat As String = "0.00",
         '                                    Optional sControlName As String = "Value check failed") As String

         tbo_FlowRate_LitersPerMin_MinVal.Text = CheckAndFormatValue(tbo_FlowRate_LitersPerMin_MinVal.Text, _
                                                                     dWaterFlow_LitersPerMin_MaxVal, _
                                                                     dWaterFlow_LitersPerMin_MinVal, _
                                                                     "The """ & sTextBoxName & """ value must not", "l/min", _
                                                                     csStandardFormatForFlowRateInLiters, _
                                                                     sControlName & "-" & sTextBoxName)
      End If

   End Sub

   'tbo_TextBox_TextChanged(): wird in einem der Steuerelemente von "Handles' ein Wert geaendert, wird die Hintergrundfarbe des Steuerelements geaendert
   Private Sub tbo_TextBox_TextChanged(sender As System.Object, e As System.EventArgs) Handles tbo_PulsesPerLiter.TextChanged, _
                                                                                               tbo_FlowRate_LitersPerMin_MinVal.TextChanged
      Dim tboChangedTextBox As TextBox = DirectCast(sender, TextBox)

      If bFormLoaded = True Then
         Call ShowAsterisk(True)
         tboChangedTextBox.BackColor = FriendGlobal_ChangedBackColor
      End If

   End Sub

   'chk_ExpandControl_CheckedChanged(): der ControlSwitch (einklappen/ausklappen des Controls) wurde betaetigt
   Private Sub chk_ExpandControl_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chk_ExpandControl.CheckedChanged
      Call chk_ExpandControl_DoWork()
   End Sub

   'chk_ExpandControl_DoWork(): Control ausgeklappt (ControlSwitch.Checked = True) oder nicht
   Public Sub chk_ExpandControl_DoWork()

       Dim sTempAsterisk As String = ""

      'Testen ob am Anfang der 'chk_ExpandControl_DoWork.Text' Beschriftung ein "*" steht.
      'Wenn JA muss dieses auch dort bleiben.
      If chk_ExpandControl.Text <> "" Then
         If chk_ExpandControl.Text.Substring(0, 1) = "*" Then
            sTempAsterisk = "*"
         End If
      End If

      If chk_ExpandControl.Checked = True Then

         chk_ExpandControl.Height = ciExpandControlButtonSizeHeightWhenControlExpanded           'Hoehe des Button zum Einklappen des Controls (i.d.R. = Hoehe des Button bei eingeklapptem Control)
         chk_ExpandControl.Width = ciControlSizeWidthWhenControlExpanded - 2        'Breite des Button zum Einklappen des Controls (i.d.R. = Breite des ausgeklapptem Control)
         Me.Height = iControlSizeHeightWhenControlExpanded                          'Hoehe des Control (ausgeklappt)
         Me.Width = ciControlSizeWidthWhenControlExpanded                           'Breite des Control (ausgeklappt)
         Me.BorderStyle = Windows.Forms.BorderStyle.FixedSingle   'Rahmen des ausgeklappten Control hat eine einfache Linie
         'TempNameLabel = sControlName
         Me.BringToFront()                                        'Control nach vorne an den Anfang der z-Reihenfolge

      Else

         chk_ExpandControl.Height = ciExpandControlButtonSizeHeightWhenControlNOTExpanded           'Hoehe des Button zum Ausklappen des Controls (i.d.R. = Hoehe des Button bei ausgeklapptem Control)
         chk_ExpandControl.Width = ciExpandControlButtonSizeWidthWhenControlNOTExpanded             'Breite des Button zum ausklappen des Controls (i.d.R. = Breite des eingeklapptem Control)
         Me.Height = ciExpandControlButtonSizeHeightWhenControlNOTExpanded                          'Hoehe des Control (eingeklappt), nur Button
         Me.Width = ciExpandControlButtonSizeWidthWhenControlNOTExpanded                            'Breite des Control (eingeklappt), nur Button
         Me.BorderStyle = Windows.Forms.BorderStyle.None          'kein Rahmen bei eineklapptem Control
         'TempNameLabel = sControlName
         Me.SendToBack()

      End If

      If bLiveViewEnabled = True Then                           'Ausgangswert der Durchflussmessung anstelle des Control-Namen auf dem 'ControlSwitch' anzeigen

         chk_ExpandControl.Font = New Drawing.Font("Microsoft Sans Serif", 10, Drawing.FontStyle.Regular)   'grosse Schrift

         If dValueToBeShownInLiveView < ConvertStringToDouble(tbo_FlowRate_LitersPerMin_MinVal.Text) Then
            chk_ExpandControl.Text = sTempAsterisk & "Flow rate to low " & dValueToBeShownInLiveView.ToString(csStandardFormatForVoltagesInLiveView) & "l/min"
         Else
            If dValueToBeShownInLiveView > ConvertStringToDouble(lbl_FlowRate_LitersPerMin_MaxVal.Text) Then
               chk_ExpandControl.Text = sTempAsterisk & "Flow rate to high " & dValueToBeShownInLiveView.ToString(csStandardFormatForVoltagesInLiveView) & "l/min"
            Else
               chk_ExpandControl.Text = sTempAsterisk & "Flow rate = " & dValueToBeShownInLiveView.ToString(csStandardFormatForVoltagesInLiveView) & "l/min"
            End If
         End If

         chk_ExpandControl.BackColor = SetColorDependingOnValue(dValueToBeShownInLiveView, dWaterFlow_LitersPerMin_MaxVal, ConvertStringToDouble(tbo_FlowRate_LitersPerMin_MinVal.Text), FriendGlobal_ColorError, FriendGlobal_ColorOK)

      Else

         chk_ExpandControl.Font = New Drawing.Font("Microsoft Sans Serif", 8.25, Drawing.FontStyle.Regular) 'kleine Schrift
         chk_ExpandControl.Text = sTempAsterisk & sControlName                                              'Name des Controls ausgeben
         chk_ExpandControl.ForeColor = Drawing.Color.Black                                                  'Vordergrundfarbe auf schwarz
         chk_ExpandControl.BackColor = Drawing.SystemColors.Control                                         'Hintergrundfarbe auf Systemeinstellung

      End If

   End Sub

   'sCalcValidMinTimeBetweenTwoPulses_in_us(): Errechnet die minimal Pulspause und gibt diese als Hex-String zurück.
   Private Function sCalcValidMinTimeBetweenTwoPulses_in_us() As String

      If ConvertStringToDouble(tbo_FlowRate_LitersPerMin_MinVal.Text) > 0 And ConvertStringToDouble(tbo_PulsesPerLiter.Text) > 0 Then
         sCalcValidMinTimeBetweenTwoPulses_in_us = ConvertLongToHexString(CLng((1 / (ConvertStringToDouble(tbo_FlowRate_LitersPerMin_MinVal.Text) * (ConvertStringToDouble(tbo_PulsesPerLiter.Text) / 60)) * 1000000)), 4)
      Else
         If cbo_WaterflowmeterType.SelectedIndex = eFlowMeterType.Float_Type_or_norm_Interlock Then
            sCalcValidMinTimeBetweenTwoPulses_in_us = "0000"
         Else
            sCalcValidMinTimeBetweenTwoPulses_in_us = "7FFF"
         End If
      End If

   End Function

   'f_sFSPxxx_ValidMinTimeBetweenTwoPulses_in_us(): Baut den FSP Inhalt der Wasser-Durchflussmessung-Parametrierung zusammen.
   Public Function f_sFSPxxx_ValidMinTimeBetweenTwoPulses_in_us() As String
      Return sCalcValidMinTimeBetweenTwoPulses_in_us()
   End Function

   'f_dCalcFlowValueInLiters(): Erhält 'dTimeBetweenTwoPulses_in_us' und berechnet daraus den aktuellen Durchflusswert in Liter
   Public Function f_dCalcFlowValueInLiters(dTimeBetweenTwoPulses_in_us As Long) As Double

      If (dTimeBetweenTwoPulses_in_us >= &H7FFF) Or (ConvertStringToDouble(tbo_PulsesPerLiter.Text) <= 0) Then
         Return 0
      Else
         Return ((60 / ConvertStringToDouble(tbo_PulsesPerLiter.Text)) * (1 / ((&H7FFF - dTimeBetweenTwoPulses_in_us) / 1000000)))
      End If

   End Function

   'WaterflowmeterType_SelectedIndexChanged():
   Private Sub WaterflowmeterType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cbo_WaterflowmeterType.SelectedIndexChanged

      Select Case cbo_WaterflowmeterType.SelectedIndex

         '----------------------------------------------------------------
         Case eFlowMeterType.Float_Type_or_norm_Interlock    'Schwebekegel, bzw. normales Interlock

            dWaterFlow_LitersPerMin_MaxVal = 0
            dWaterFlow_LitersPerMin_MinVal = 0

            tbo_PulsesPerLiter.Text = "0"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpandedFloatTypeOrNormInterlock

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.Customized_Values

            dWaterFlow_LitersPerMin_MaxVal = 500
            dWaterFlow_LitersPerMin_MinVal = 0

            tbo_PulsesPerLiter.Text = "0"
            tbo_PulsesPerLiter.Enabled = True

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()



            '----------------------------------------------------------------
         Case eFlowMeterType.RRI_010XXX020_2l

            dWaterFlow_LitersPerMin_MaxVal = 1.8
            dWaterFlow_LitersPerMin_MinVal = 0.2

            tbo_PulsesPerLiter.Text = "10200"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.RRI_010XXX050_12l

            dWaterFlow_LitersPerMin_MaxVal = 12
            dWaterFlow_LitersPerMin_MinVal = 0.6

            tbo_PulsesPerLiter.Text = "3345"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.RRI_010XXX070_14l

            dWaterFlow_LitersPerMin_MaxVal = 14.4
            dWaterFlow_LitersPerMin_MinVal = 1.1

            tbo_PulsesPerLiter.Text = "1755"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.RRI_025XXX080_36l

            dWaterFlow_LitersPerMin_MaxVal = 36
            dWaterFlow_LitersPerMin_MinVal = 1.6

            tbo_PulsesPerLiter.Text = "1216"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.RRI_025XXX120_72l

            dWaterFlow_LitersPerMin_MaxVal = 72
            dWaterFlow_LitersPerMin_MinVal = 3.1

            tbo_PulsesPerLiter.Text = "607"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.RRI_025XXX160_120l

            dWaterFlow_LitersPerMin_MaxVal = 120
            dWaterFlow_LitersPerMin_MinVal = 7.3

            tbo_PulsesPerLiter.Text = "252"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

            '----------------------------------------------------------------
         Case eFlowMeterType.DRS_9250XXF300

            dWaterFlow_LitersPerMin_MaxVal = 40
            dWaterFlow_LitersPerMin_MinVal = 3.2

            tbo_PulsesPerLiter.Text = "576"
            tbo_PulsesPerLiter.Enabled = False

            iControlSizeHeightWhenControlExpanded = ciControlSizeHeightWhenControlExpanded

            Call chk_ExpandControl_DoWork()

      End Select

      lbl_FlowRate_LitersPerMin_MaxVal.Text = dWaterFlow_LitersPerMin_MaxVal.ToString(csStandardFormatForFlowRateInLiters)
      tbo_FlowRate_LitersPerMin_MinVal.Text = dWaterFlow_LitersPerMin_MinVal.ToString(csStandardFormatForFlowRateInLiters)


      'ggf. den Tooltip aktualisieren sofern der Standard-ToolTip nicht ueberschrieben wurde
      If CBool(ToolTip.GetToolTip(Me.chk_ExpandControl).Contains("The module is currently parameterized as follows:")) Then

         Call UpdateToolTip()

      End If

      If bFormLoaded = True Then
         Call ShowAsterisk(True)
         cbo_WaterflowmeterType.BackColor = FriendGlobal_ChangedBackColor
      End If

   End Sub

End Class
