﻿Option Strict On

Imports System.Drawing
Imports System.Globalization
Imports System.Windows.Forms
Imports System.ComponentModel
Imports ShowMessage
Imports Microsoft.VisualBasic


Public Module GlobaleElemente

    Public Enum cInterlockType
        cDisabled = 0
        cAnalog = 1
        cDigitalElectrical = 2
        cDigitalOptical = 3
        cPulsedWater = 4
        cInternal = 5
        cAnalogSoftware = 6
        cDigitalSoftware = 7
        'cModuleNotFound = 8
    End Enum

    Public BackColorAnalogInterlock As Color = Color.FromArgb(255, 193, 226, 253)
    Public BackColorAnalogSoftwareInterlock As Color = Color.FromArgb(255, 193, 226, 200)
    Public BackColorDigitalInterlock As Color = Color.FromArgb(255, 235, 240, 164)
    Public BackColorDigitalSoftwareInterlock As Color = Color.FromArgb(255, 210, 220, 164)
    Public BackColorDigitalOpticalInterlock As Color = Color.FromArgb(255, 207, 237, 223)
    Public BackColorPulsedWaterInterlock As Color = Color.SkyBlue
    Public BackColorUndefinedInterlock As Color = Color.DarkGray

   '(piMaxNumberOfTripLines)                           (0..4) => Maximale Anzahl verfügbarer Reissleinen   
   '(pbchk_NewInterlockModel_Visible)                  True   => Checkbox zum Umschalten des Interlockmodells anzeigen
   '(pbchk_NewInterlockModel_Checked)                  True   => neues Interlockmodell mit Unterstützung zeitverzögerter Interlocks, (FALSE = altes Modell)
   '(piInterlockBitIndex)                              (0..n) => Um einen Interlockeintrag gezielt anzusprechen wird hiermit das Bit ausgewählt
   '(piNumberOfInterlockListEntries)                   (0..n) => Liefert die Anzahl von Einträgen in der Interlockliste (nur GET!)
   '(piInterlockBitNumberForMainContactor)             (0..n) => Legt fest, bzw. liefert den Index für das ´Hauptschütz-Interlock
   '(piInterlockBitNumberForPSS)                       (0..n) => Legt fest, bzw. liefert den Index für das PSS Interlock
   '(piInterlockBitNumberForExternalControllerLock     (0..n) => Legt fest, bzw. liefert den Index für das Interlock zur externen Reglersperre
   '(piInterlockBitNumberForModuleControllerLock)      (0..n) => Legt fest, bzw. liefert den Index für das Interlock zur direkten Reglersperre
   '(pbcbo_PSSInterlockBit_Visible)                    True   => Wenn TRUE wird die PSS Auswahl angezeigt
   '(pbcbo_ExternalControllerLockInterlockBit_Visible) True   => Wenn TRUE wird die Externe Reglersperre Auswahl angezeigt
   '(pbcbo_ModuleControllerLockInterlockBit_Visible)   True   => Wenn TRUE wird die direkten Reglersperre Auswahl angezeigt
   '(pbcbo_MainContactorInterlockBit_Visible)          True   => Wenn TRUE wird die externe Reglersperre Auswahl angezeigt
   '(pbchk_InterlockRefreshGaugeableValues_Checked)    True   => Wenn TRUE ist es möglich Interlockzustände dynamisch anzeigen zu lassen, indem die InterlockRefreshGaugeableValues-Checkbox sichtbar ist

   '* Teil der Parameter in .XPC3
   'x nicht Teil der Parameter, darf aber beim Laden der Parameter nicht verändert werden
   '- irrelevant, das Refresh-Daten

   '=> * und x werden mit "Add...()" Funktionen gesetzt
   '=> nur * wird bei "Copy...()" Funktionen verändert, x wird NICHT verändert!

    Friend Structure sInterlock

      Friend iInterlockType As Integer                          ' *(piInterlockType)                          Fügt den Interlocktyp hinzu (siehe GlobaleElements.cInterlockType) (Elektrisch, Optisch, Analog...)
      Friend sInterlockName As String                           ' *(psInterlockName)                          Name des Interlocks als String
      Friend sInterlockTFTDisplayedName As String               ' *(psInterlockTFTDisplayedName)              Der Name des Interlocks für die Anzeige auf dem TFT der MFU (i.d.R. psInterlockName, kann aber auch abweichen)
      Friend bInterlockBitIsInUse As Boolean                    ' *(pbInterlockBitIsInUse)                    Interlock ist aktiv (wird dadurch benutzbar)
      Friend bHWDisableJumperAvailable As Boolean               ' x(pbHWDisableJumperAvailable)               True   => es gibt keine 'bInterlockArmedByHWJumperSetValue' und 'bInterlockArmedByHWJumperActualValue' Jumper  für dieses Interlock
      Friend bInterlockArmedByHWJumperSetValue As Boolean       ' *(pbInterlockArmedByHWJumperSetValue)       HW-Jumperstellung (Sollwert) ( falls vorhanden )
      Friend bInterlockArmedByHWJumperActualValue As Boolean    ' -(pbInterlockArmedByHWJumperActualValue)    HW-Jumperstellung (Istwert) ( falls vorhanden )
      Friend dInterlockFilterRValue As Double                   ' *(pdInterlockFilterRValue)                  Widerstandwert bei vorhandenem Filter ( falls vorhanden )
      Friend dInterlockFilterCValue As Double                   ' *(pdInterlockFilterCValue)                  Kondensatorwert bei vorhandenem Filter ( falls vorhanden )
      Friend bInterlockComparatorValuePositive As Boolean       ' *(pbInterlockComparatorValuePositive)       True = Positiv ( Value größer Schwelle => Interlock )  / False = Negativ ( Value kleiner Schwelle => Interlock ) ( falls vorhanden )
      Friend dInterlockComparatorThresholdSetValue As Double    ' *(pdInterlockComparatorThresholdSetValue)   Komparator Sollwert
      Friend dInterlockComparatorMeasuredActualValue As Double  ' -(pdInterlockComparatorMeasuredActualValue) Komparator Istwert (Messwert)

      Friend sThresholdstringActValue As String                 '                                            Der Schwellwert für den Komparator als String für den Vergleich

      Friend lInterlockComparatorFilterModuleID As Long         ' *(plInterlockComparatorFilterModuleID)      Die Seriennnummer bei einem Analogen-Filtermodule ( 64BitNr des OneWire Chips )

      Friend bInterlockToTriplineConnectionIsEditable As Boolean 'x(pbInterlockToTriplineConnectionIsEditable)   Die Reissleinenanbindung dieses Interlocks ist editierbar

      Friend bInterlockIsConnectableToTripline1 As Boolean      ' x(pbInterlockIsConnectableToTripline1)      Interlock anbindbar an Reissleine 1 (True) oder nicht
      Friend bInterlockIsConnectableToTripline2 As Boolean      ' x(pbInterlockIsConnectableToTripline2)      Interlock anbindbar an Reissleine 2 (True) oder nicht
      Friend bInterlockIsConnectableToTripline3 As Boolean      ' x(pbInterlockIsConnectableToTripline3)      Interlock anbindbar an Reissleine 3 (True) oder nicht
      Friend bInterlockIsConnectableToTripline4 As Boolean      ' x(pbInterlockIsConnectableToTripline4)      Interlock anbindbar an Reissleine 4 (True) oder nicht

      Friend bInterlockConnectedToTripline1 As Boolean          ' *(pbInterlockConnectedToTripline1)          Interlock angebunden an Reissleine 1 (True) oder nicht (Info)
      Friend bInterlockConnectedToTripline2 As Boolean          ' *(pbInterlockConnectedToTripline2)          Interlock angebunden an Reissleine 2 (True) oder nicht (Info)
      Friend bInterlockConnectedToTripline3 As Boolean          ' *(pbInterlockConnectedToTripline3)          Interlock angebunden an Reissleine 3 (True) oder nicht (Info)
      Friend bInterlockConnectedToTripline4 As Boolean          ' *(pbInterlockConnectedToTripline4)          Interlock angebunden an Reissleine 4 (True) oder nicht (Info)

      Friend bInterlockNotPending As Boolean                    ' -(pbInterlockNotPending)                    Bit für anstehendes Interlock             (True = KEIN Interlock anstehend)
      Friend bInterlockNotMemorized As Boolean                  ' -(pbInterlockNotMemorized)                  Bit für gespeichertes Interlock           (True = KEIN Interlock gespeichert)
      Friend bCapturePendingInterlock As Boolean                ' *(pbCapturePendingInterlock)                Bit für Bitmaske anstehendes Interlock    (True = nicht erfassen)
      Friend bCaptureMemorizedInterlock As Boolean              ' *(pbCaptureMemorizedInterlock)              Bit für Bitmaske gespeichertes Interlock  (True = nicht erfassen)

      Friend bInterlockSupportsConditonalEnable As Boolean      ' x(pbInterlockSupportsConditonalEnable)      True = Dieses Interlock unterstütztz die zeitverzögerte Interlockaktivierung bei neuem Interlockmodell
      Friend bInterlockConditionallyEnabled As Boolean          ' *(pbInterlockConditionallyEnabled)          True = Dieses Interlock wird zeitverzögert aktiviert bei neuem Interlockmodell

      Friend bInterlockSupportsDigitalFilter As Boolean         ' wenn true, besitzt dieses Interlock ein digitales Eingangsfilter

      Friend bInterlockDigitalFilterIsEnabled As Boolean           ' wenn true, ist das digitale Eingangsfilter für dieses Interock aktiviert

    End Structure


    ' The procedure below is used to change the "language" setting to the german ones.
    ' It is used in the main code, but in order to debug the single controllers, it has to be used 
    ' in the load controller function.
    Friend Sub ChangeCulture() 'legt die System-eigenschaften fest. Schaltet ein System auf "de(utsch)" um

        Dim current As CultureInfo = CultureInfo.CurrentCulture

        If current.Name.Equals("de-DE") = False Then
            My.Application.ChangeCulture("de")
        End If

    End Sub

    Public Function f_sConvertInterlockFormTypeToString(Type As Integer) As String

        Select Case Type
            Case cInterlockType.cAnalog
                f_sConvertInterlockFormTypeToString = "Analog interlock"
            Case cInterlockType.cAnalogSoftware
                f_sConvertInterlockFormTypeToString = "Analog Software interlock"
            Case cInterlockType.cDigitalElectrical
                f_sConvertInterlockFormTypeToString = "Digital eletrical interlock"
            Case cInterlockType.cDigitalSoftware
                f_sConvertInterlockFormTypeToString = "Digital software interlock"
            Case cInterlockType.cDigitalOptical
                f_sConvertInterlockFormTypeToString = "Digital optical interlock"
            Case cInterlockType.cPulsedWater
                f_sConvertInterlockFormTypeToString = "Pulsed Water interlock"
            Case cInterlockType.cInternal
                f_sConvertInterlockFormTypeToString = "Internal interlock"
            Case cInterlockType.cDisabled
                f_sConvertInterlockFormTypeToString = "Undefined or disabled"
            Case Else
                f_sConvertInterlockFormTypeToString = "Undefined or disabled"
        End Select
    End Function

    Public Function f_iConvertInterlockFormStringtoType(Type As String) As Integer

        Select Case Type
            Case "Analog interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cAnalog
            Case "Analog Software interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cAnalogSoftware
            Case "Digital eletrical interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cDigitalElectrical
            Case "Digital software interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cDigitalSoftware
            Case "Digital optical interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cDigitalOptical
            Case "Pulsed Water interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cPulsedWater
            Case "Internal interlock"
                f_iConvertInterlockFormStringtoType = cInterlockType.cInternal
            Case "Undefined or disabled"
                f_iConvertInterlockFormStringtoType = cInterlockType.cDisabled
            Case Else
                f_iConvertInterlockFormStringtoType = cInterlockType.cDisabled
        End Select
    End Function

    Friend FriendGlobal_UnchangedBackColor As Drawing.Color = Color.White
    Friend FriendGlobal_ChangedBackColor As Drawing.Color = Color.LightSalmon

    'Public FriendGlobal_dLSBValue As Double = 22 / ((2 ^ 32) - 1)

    Friend FriendGlobal_ColorOK As Drawing.Color = Color.LightGreen
    Friend FriendGlobal_ColorError As Drawing.Color = Color.LightCoral
    Friend FriendGlobal_ColorDisabled As Drawing.Color = Color.LightCyan
    Friend FriendGlobal_ColorWarning As Color = Color.LightYellow

    'Convertiert Dezimal-Werte nach Binär-Werte
    Friend Function ConvertDecimalToBinary(ByVal Value As Integer) As String
        Return Convert.ToString(Value, 2)
    End Function

    ''Convertiert Binär-Werte nach Dezimal-Werte
    'Public Function ConvertBinaryToDecimal(ByVal Value As String) As Integer

    '   Dim IntValue As Integer

    '   For Bitcount As Integer = 0 To Value.Length - 1
    '      IntValue = (IntValue << 1) + Integer.Parse(Value.Substring(Bitcount, 1))
    '   Next

    '   Return IntValue

    'End Function

    Friend Function GenerateBitValue(BitNr As Integer, Value As Boolean) As Long
        If Value = True Then
            GenerateBitValue = CLng(2 ^ BitNr)
        Else
            GenerateBitValue = 0
        End If
    End Function

    'Setzt eine Farbe abhängig davon ob 'Value' innerhalb von 'MaxValue' und 'MinValue' ist oder nicht.
    Friend Function SetColorDependingOnValue(dValue As Double, dMaxValue As Double, dMinValue As Double, ColorValueOutOfWindow As Color, ColorValueInWindow As Color) As Color

        If dValue >= dMaxValue Or dValue <= dMinValue Then
            SetColorDependingOnValue = ColorValueOutOfWindow
        Else
            SetColorDependingOnValue = ColorValueInWindow
        End If

    End Function

   'Setzt eine Farbe abhängig davon wo sich 'ActualValue' befindet.
   ' dActualValue    - aktueller Messwert
   ' dThreshold      - Grenzwert
   ' dPlusMinusRange - Toleranz
   ' bBottomUp - gibt an, ob die Kompartorschwelle von unten nach oben durchschritten wird => TRUE   ___| Threshold wird von klein nach groß durchschritten
   '                                                                                       => FALSE  ---| Threshold wird von groß nach klein durchschritten
   ' ColorWithinTheRange - Farbe wenn alles OK ist, dActualValue ist kleiner und deutlich von dThreshold
   ' ColorBorderline - Farbe wenn dActualValue innerhalb dThreshold +/- dPlusMinusRange
   ' ColorOutOfRange - Farbe wenn dActualValue größer dThreshold +/- dPlusMinusRange

    Friend Function SetColorDependingOnValueAdvanced(dActualValue As Double, dThreshold As Double, dPlusMinusRange As Double, bBottomUp As Boolean, bIsWaterFlow As Boolean, ColorWithinTheRange As Color, ColorBorderline As Color, ColorOutOfRange As Color) As Color

      If bIsWaterFlow = False Then

         Dim dSmallestPermittedValue As Double = dThreshold - dPlusMinusRange
         Dim dSmallestPermittedValueIncludingBoarderLine As Double = dThreshold - dPlusMinusRange + (0.125 * dPlusMinusRange)
         Dim dHighestPermittedValue As Double = dThreshold + dPlusMinusRange
         Dim dHighestPermittedValueIncludingBoarderLine As Double = dThreshold + dPlusMinusRange - (0.125 * dPlusMinusRange)

         'Die Interlocks werden ausgelöst, wenn eine Schwelle über- (positiv => bottom up = TRUE) oder unterschritten (negativ => bottom up = FALSE) wird.

         '-0,175(spvibl) < 0,1(act) < 0,177 (hpvibl)
         If dActualValue >= dSmallestPermittedValueIncludingBoarderLine And dActualValue <= dHighestPermittedValueIncludingBoarderLine Then    'innerhalb der Toleranz
            SetColorDependingOnValueAdvanced = ColorWithinTheRange 'ColorBorderline
         Else

            'Messwert nähert sich von unten an Schwellwert an
            'True = Positiv ( Value größer Schwelle => Interlock )
            If bBottomUp = True Then

               'Komparator
               'AktuellerWert|Schwellwert|Toleranz|BoarderLine       |untere Schwelle       |obere Schwelle       |Farbe|
               '---------------------------------------------------------------------------------------------------------------
               ' 9,84          10        +/-0,2    -/+ 1/8 Toleranz   10-0,2+0,025 =  9,825  10+0,2-0,025= 10,175  ColorWithinTheRange
               ' 9,81          10        +/-0,2    -/+ 1/8 Toleranz   10-0,2+0,025 =  9,825  10+0,2-0,025= 10,175  ColorBorderline
               ' 9,79          10        +/-0,2    -/+ 1/8 Toleranz   10-0,2+0,025 =  9,825  10+0,2-0,025= 10,175  ColorOutOfRange
               '10,15          10        +/-0,2    -/+ 1/8 Toleranz   10-0,2+0,025 =  9,825  10+0,2-0,025= 10,175  ColorWithinTheRange

               ' 0,0          - 1        +/-0,2    -/+ 1/8 Toleranz   -1-0,2+0,025 = -1,175 -1+0,2-0,025=  -0,875  ColorOutOfRange
               '-0,9          - 1        +/-0,2    -/+ 1/8 Toleranz   -1-0,2+0,025 = -1,175 -1+0,2-0,025=  -0,875  ColorWithinTheRange

               'dActualValue  = 0,810 / 1,180
               'dThreshold    = 1

               'dSmallestPermittedValue = 0,8
               'dSmallestPermittedValueIncludingBoarderLine = 0,825
               'dHighestPermittedValue = 1,2
               'dHighestPermittedValueIncludingBoarderLine = 1,175

               ' 0,8            <  0,810 <  0,825 (spvibl)  ODER
               ' 1,175(spvibl)  <  1,180 <  1,2

               If (dActualValue >= dSmallestPermittedValue And _
                   dActualValue <= dSmallestPermittedValueIncludingBoarderLine) Or _
                  (dActualValue >= dHighestPermittedValueIncludingBoarderLine And _
                   dActualValue <= dHighestPermittedValue) Then
                  SetColorDependingOnValueAdvanced = ColorBorderline
               Else
                  SetColorDependingOnValueAdvanced = ColorOutOfRange
               End If


               'If (dActualValue >= dSmallestPermittedValue And _
               '    dActualValue <= dSmallestPermittedValueIncludingBoarderLine) Or _
               '   (dActualValue <= dHighestPermittedValueIncludingBoarderLine And _
               '    dActualValue >= dHighestPermittedValue) Then
               '   SetColorDependingOnValueAdvanced = ColorBorderline
               'Else
               '   SetColorDependingOnValueAdvanced = ColorOutOfRange
               'End If

            'Messwert nähert sich von oben an Schwellwert an
            'False = Negativ ( Value kleiner Schwelle => Interlock ) ( falls vorhanden )
            Else

               'AktuellerWert|Schwellwert|Toleranz|BoarderLine       |untere Schwelle         |obere Schwelle         |Farbe|
               '---------------------------------------------------------------------------------------------------------------
               '- 9,84          -10       +/-0,2    -/+ 1/8 Toleranz   -10+0,2-0,025 = -9,825  -10-0,2+0,025= -10,175  ColorWithinTheRange
               '- 9,81          -10       +/-0,2    -/+ 1/8 Toleranz   -10+0,2-0,025 = -9,825  -10-0,2+0,025= -10,175  ColorBorderline
               '- 9,79          -10       +/-0,2    -/+ 1/8 Toleranz   -10+0,2-0,025 = -9,825  -10-0,2+0,025= -10,175  ColorOutOfRange
               '-10,15          -10       +/-0,2    -/+ 1/8 Toleranz   -10+0,2-0,025 = -9,825  -10-0,2+0,025= -10,175  ColorWithinTheRange

               '- 0,0            1        +/-0,2    -/+ 1/8 Toleranz     1+0,2-0,025 =  1,175    1-0,2+0,025=   0,875  ColorOutOfRange
               '  0,9            1        +/-0,2    -/+ 1/8 Toleranz     1+0,2-0,025 =  1,175    1-0,2+0,025=   0,875  ColorWithinTheRange

               'dActualValue  = -0,810 / -1,180
               'dThreshold    = -1

               'dSmallestPermittedValue = -0,8
               'dSmallestPermittedValueIncludingBoarderLine = -0,825
               'dHighestPermittedValue = -1,2
               'dHighestPermittedValueIncludingBoarderLine = -1,175

               ' -0,8            >  -0,810 >  -0,825 (spvibl)  ODER
               ' -1,175(spvibl)  >  -1,180 >  -1,2

               If (dActualValue <= dHighestPermittedValue And _
                   dActualValue >= dHighestPermittedValueIncludingBoarderLine) Or _
                  (dActualValue <= dSmallestPermittedValueIncludingBoarderLine And _
                   dActualValue >= dSmallestPermittedValue) Then
                  SetColorDependingOnValueAdvanced = ColorBorderline
               Else
                  SetColorDependingOnValueAdvanced = ColorOutOfRange
               End If

            End If

         End If

      Else

         'WaterFlow
         'Schwellwert|Toleranz|AktuellerWert|Farbe|
         '-----------------------------------------------
         ' 5l/min     +/-0,2   4l/min        rot     AktuellerWert < Schwellwert - Toleranz
         ' 5l/min     +/-0,2   6l/min        grün    AktuellerWert > Schwellwert + Toleranz            

         If dActualValue < dThreshold - dPlusMinusRange Then         'kleiner Schwelle - Toleranz
            SetColorDependingOnValueAdvanced = ColorOutOfRange
         ElseIf dActualValue > dThreshold + dPlusMinusRange Then     'größer Schwelle + Toleranz
            SetColorDependingOnValueAdvanced = ColorWithinTheRange
         Else
            SetColorDependingOnValueAdvanced = ColorBorderline
         End If

      End If

   End Function

   'Text          - Wert den es zu vergleichen gilt, i.d.R. .Text einer Textbox
   'Maxvalue      - max. zulaessiger Wert
   'MinValue      - min. zulaessiger wert
   'ErrorText     - wird dieser nicht angegeben wird "The value must not" verwendet
   'Unit          - wird diese nicht angegeben wird "V" verwendet
   'NumberFormat  - wird dies nicht angegeben wird 0.00 verwendet
   'sControlName  - wird dies nicht angegeben wird "Value check failed" verwendet
   Friend Function CheckAndFormatValue(Text As String,
                                       MaxValue As Double,
                                       MinValue As Double,
                                       Optional ErrorText As String = "The value must not",
                                       Optional Unit As String = "V",
                                       Optional NumberFormat As String = "0.00",
                                       Optional sControlName As String = "Value check failed") As String

      Dim TempOutput As Double
      Dim TextChanged As Boolean = False

      If Text <> "" Then

         If IsNumeric(Text) = True Then

            'Befindet sich ein Punkt als Dezimaltrennzeichen in "Text", diesen durch ein Komma ersetzen.
            'If InStr(Text, ".") > 0 Then
               Text = Replace(Text, ".", ",")
            'End If

            If ConvertStringToDouble(Text) > MaxValue Then

               'ShowMsg(ErrorText & " exceed " & Format(MaxValue, NumberFormat) & Unit & "!", ShowMsgImage.Alert, sControlName)

               TempOutput = MaxValue
               TextChanged = True

            Else

               If ConvertStringToDouble(Text) < MinValue Then
                  'ShowMsg(ErrorText & " fall below " & Format(MinValue, NumberFormat) & Unit & "!", ShowMsgImage.Alert, sControlName)
                  TempOutput = MinValue
                  TextChanged = True
               Else
                  TempOutput = ConvertStringToDouble(Text)
               End If

            End If

         Else

            'ShowMsg("The input value contained invalid data and was set to 0,00 " & Unit & ".", ShowMsgImage.Alert, sControlName)
            TempOutput = 0

         End If

         CheckAndFormatValue = Format(TempOutput, NumberFormat)

      Else

         CheckAndFormatValue = CStr(MinValue)

      End If

   End Function

    'Konvertiert 'LongValue' in einen HEX String-Wert
    '"LengthOfStringInNibbles" gibt dabei die Anzahl von Hex-Nibbles des Returnwerts an
    Friend Function ConvertLongToHexString(ByVal LongValue As Long, ByVal LengthOfStringInNibbles As Integer) As String
        ConvertLongToHexString = Microsoft.VisualBasic.Right("0000000000" & Hex(LongValue), LengthOfStringInNibbles)
    End Function

    'Public Function CALC_DOUBLE_TO_LONG(ByVal INPUT As Double) As Long
    '   CALC_DOUBLE_TO_LONG = CLng(INPUT / FriendGlobal_dLSBValue)
    'End Function

    'Public Function CALC_LONG_TO_DOUBLE(ByVal INPUT As Integer) As Double
    '   CALC_LONG_TO_DOUBLE = CDbl(INPUT * FriendGlobal_dLSBValue)
    'End Function

    'Konvertiert einen String-Wert in einen Double-Wert
    Friend Function ConvertStringToDouble(ByVal StringValue As String) As Double

        If Len(StringValue) = 0 Then
            ConvertStringToDouble = 0
        Else

            If InStr(StringValue, ".") > 0 Then
                StringValue = Replace(StringValue, ".", ",")
            End If

            StringValue = Replace(StringValue, "V", "")
            StringValue = Replace(StringValue, "A", "")
            StringValue = Replace(StringValue, "x", "")
            StringValue = Replace(StringValue, "X", "")

            If IsNumeric(StringValue) = False Then
                ConvertStringToDouble = 0
            Else
                ConvertStringToDouble = CDbl(StringValue)
            End If

        End If

    End Function

    'ersetzt ggf. Umlaut
    Friend Function ReplaceMutatedVowels(ByVal INPUT As String) As String
        INPUT = Replace(INPUT, "Ä", "Ae")
        INPUT = Replace(INPUT, "Ö", "Oe")
        INPUT = Replace(INPUT, "Ü", "Ue")
        INPUT = Replace(INPUT, "ä", "ae")
        INPUT = Replace(INPUT, "ö", "oe")
        INPUT = Replace(INPUT, "ü", "ue")
        INPUT = Replace(INPUT, "ß", "ss")
        ReplaceMutatedVowels = INPUT
    End Function

    'Konvertiert einen Double-Wert in einen HEX String-Wert
    Friend Function ConvertDoubleToHexString(ByVal HexInput As Double, ByVal Length As Integer, ByVal dLSBValue As Double) As String

        Dim ValueLen As Integer
        Dim ValueStr As String

        If HexInput = 11 Then
            HexInput = HexInput - dLSBValue
        End If

        ValueStr = Hex(CLng(CDbl(HexInput) / CDbl(dLSBValue)))

        If HexInput >= 0 Then

            ValueLen = Len(Hex(CLng(CDbl(HexInput) / CDbl(dLSBValue))))

            If ValueLen < 8 Then
                ValueStr = Right("00000000", 8 - ValueLen) & ValueStr
            End If

            ConvertDoubleToHexString = Microsoft.VisualBasic.Left(ValueStr, Length)

        Else

            ConvertDoubleToHexString = Microsoft.VisualBasic.Left(Hex(CInt(CDbl(HexInput) / CDbl(dLSBValue))) & "00000000", Length)

        End If

    End Function


End Module


